<template>
  <v-card width="400px" class="seat-comment-card">
    <v-card-title class="font-weight-bold text-subtitle-1">
      Laisser un commentaire
    </v-card-title>

    <v-card-text>
      <Field #default="{ errors, field, value }" name="Observations" rules="max:255" v-model="seat.observations">
        <v-textarea @update:model-value="field.onChange" :model-value="value" label="Commentaire"
          data-cy="SeatCommentObservationInput" :error-messages="errors" hide-details="auto" rows="1" auto-grow
          variant="outlined">
          <span slot="prepend-inner">
            {{ seat.row }}{{ seat.number }}
          </span>
        </v-textarea>
      </Field>
    </v-card-text>

    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn class="text-uppercase" data-cy="SeatCommentOkBtn" variant="outlined" rounded size="large" :disabled="!meta.valid"
        @click="confirm()">
        Valider
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script setup lang="ts">
import { Seat } from "~/dto/seat.dto";

const { $api, $toast } = useNuxtApp();
const props = defineProps<{ seat: Seat }>();

const emit = defineEmits(['close'])

const { validate, meta } = useForm({
  initialValues: JSON.parse(JSON.stringify(props.seat)),
})

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  try {
    props.seat.comment = await $api.seat.comment(props.seat.observations, props.seat.id);
    emit('close');
    $toast.success("Commentaire ajouté");
  } catch (e) {
    $toast.error("Erreur lors de l'ajout du commentaire");
  }
}
</script>

<style lang="scss">
@import "../../../../assets/variables.scss";

.seat-comment-card {
  .v-card__text {
    padding-top: 0;
  }

  .v-input .v-input__prepend-inner {
    background-color: $color-secondary;
    color: $color-white;
    border-radius: 4px;
    padding: 5px 10px;
    margin: 15px 5px 0 0;
  }
}
</style>
